package com.ejie.ab79.dao;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.EnviosJson;
import com.ejie.ab79.model.InspeccionesJson;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * InspeccionesJsonDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class InspeccionesJsonDaoImpl implements InspeccionesJsonDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDINSPECCIONJSON", "IDINSPECCION",
			"IDINSPECCIONMOVIL", "ESTADO", "ERROR", "FECHAREGISTRO", "USUARIOREGISTRO", "FECHAULTMODIFICACION",
			"USUARIOULTMODIFICACION", "ENVIOSJSONIDENVIOJSON", "ENVIOSJSONAPLICACIONORIGEN",
			"ENVIOSJSONAPLICACIONDESTINO", "ENVIOSJSONIDINSPECTOR", "ENVIOSJSONJSON", "ENVIOSJSONESTADO",
			"ENVIOSJSONFECHAREGISTRO", "ENVIOSJSONUSUARIOREGISTRO", "ENVIOSJSONMETODO" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<InspeccionesJson> rwMap = new RowMapper<InspeccionesJson>() {
		public InspeccionesJson mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new InspeccionesJson(resultSet.getInt("IDINSPECCIONJSON"), resultSet.getInt("IDINSPECCION"),
					resultSet.getString("IDINSPECCIONMOVIL"), resultSet.getInt("ESTADO"), resultSet.getString("ERROR"),
					resultSet.getDate("FECHAREGISTRO"), resultSet.getString("USUARIOREGISTRO"),
					resultSet.getDate("FECHAULTMODIFICACION"), resultSet.getString("USUARIOULTMODIFICACION"),
					new EnviosJson(resultSet.getInt("EnviosJsonIDENVIOJSON"),
							resultSet.getString("EnviosJsonAPLICACIONORIGEN"),
							resultSet.getString("EnviosJsonAPLICACIONDESTINO"),
							resultSet.getInt("ENVIOSJSONIDINSPECTOR"), resultSet.getString("ENVIOSJSONMETODO"),
							resultSet.getString("ENVIOSJSONJSON"), resultSet.getInt("EnviosJsonESTADO"),
							resultSet.getDate("ENVIOSJSONFECHAREGISTRO"),
							resultSet.getString("ENVIOSJSONUSUARIOREGISTRO")));
		}
	};

	private RowMapper<InspeccionesJson> rwMapPK = new RowMapper<InspeccionesJson>() {
		public InspeccionesJson mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new InspeccionesJson(resultSet.getInt("IDINSPECCIONJSON"));
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<InspeccionesJson>> rwMapJerarquia = new RowMapper<JerarquiaDto<InspeccionesJson>>() {
		public JerarquiaDto<InspeccionesJson> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			InspeccionesJson inspeccionesjson = new InspeccionesJson(resultSet.getInt("IDINSPECCIONJSON"),
					resultSet.getInt("IDINSPECCION"), resultSet.getString("IDINSPECCIONMOVIL"),
					resultSet.getInt("ESTADO"), resultSet.getString("ERROR"), resultSet.getDate("FECHAREGISTRO"),
					resultSet.getString("USUARIOREGISTRO"), resultSet.getDate("FECHAULTMODIFICACION"),
					resultSet.getString("USUARIOULTMODIFICACION"),
					new EnviosJson(resultSet.getInt("EnviosJsonIDENVIOJSON"),
							resultSet.getString("EnviosJsonAPLICACIONORIGEN"),
							resultSet.getString("EnviosJsonAPLICACIONDESTINO"),
							resultSet.getInt("EnviosJsonIDINSPECTOR"), resultSet.getString("EnviosJsonMETODO"),
							resultSet.getString("EnviosJsonJSON"), resultSet.getInt("EnviosJsonESTADO"),
							resultSet.getDate("EnviosJsonFECHAREGISTRO"),
							resultSet.getString("EnviosJsonUSUARIOREGISTRO")));

			JerarquiaDto<InspeccionesJson> jerarquia = new JerarquiaDto<InspeccionesJson>();
			jerarquia.setModel(inspeccionesjson);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the InspeccionesJson table.
	 *
	 * @param inspeccionesjson
	 *            InspeccionesJson
	 * @return InspeccionesJson
	 */
	@Transactional(propagation = Propagation.REQUIRES_NEW, rollbackFor = Exception.class)
	public InspeccionesJson add(InspeccionesJson inspeccionesjson) {
		int idInspeccionesJson = this.jdbcTemplate.queryForObject("SELECT AB79.S_AB7935T00.NEXTVAL FROM DUAL",
				Integer.class);
		inspeccionesjson.setIdInspeccionJson(idInspeccionesJson);
		String query = "INSERT INTO INSPECCIONES_JSON (ID_INSPECCION_JSON, ID_ENVIO_JSON, ID_INSPECCION, ID_INSPECCION_MOVIL, ESTADO, ERROR, FECHA_REGISTRO, USUARIO_REGISTRO) VALUES (?,?,?,?,?,?,SYSDATE,?)";
		Object getEnviosJsonIdEnvioJsonAux = null;
		if (inspeccionesjson.getEnviosJson() != null && inspeccionesjson.getEnviosJson().getIdEnvioJson() != null) {
			getEnviosJsonIdEnvioJsonAux = inspeccionesjson.getEnviosJson().getIdEnvioJson();
		}
		this.jdbcTemplate.update(query, idInspeccionesJson, getEnviosJsonIdEnvioJsonAux,
				inspeccionesjson.getIdInspeccion(), inspeccionesjson.getIdInspeccionMovil(),
				inspeccionesjson.getEstado(), inspeccionesjson.getError(), inspeccionesjson.getUsuarioRegistro());
		return inspeccionesjson;
	}

	/**
	 * Updates a single row in the InspeccionesJson table.
	 *
	 * @param inspeccionesjson
	 *            InspeccionesJson
	 * @return InspeccionesJson
	 */
	@Transactional(propagation = Propagation.REQUIRES_NEW, rollbackFor = Exception.class)
	public InspeccionesJson update(InspeccionesJson inspeccionesjson) {
		String query = "UPDATE INSPECCIONES_JSON SET ID_ENVIO_JSON=?, ID_INSPECCION=?, ID_INSPECCION_MOVIL=?, ESTADO=?, ERROR=?, FECHA_ULTMODIFICACION=SYSDATE, USUARIO_ULTMODIFICACION=? WHERE ID_INSPECCION_JSON=?";
		Object getEnviosJsonIdEnvioJsonAux = null;
		if (inspeccionesjson.getEnviosJson() != null && inspeccionesjson.getEnviosJson().getIdEnvioJson() != null) {
			getEnviosJsonIdEnvioJsonAux = inspeccionesjson.getEnviosJson().getIdEnvioJson();
		}
		this.jdbcTemplate.update(query, getEnviosJsonIdEnvioJsonAux, inspeccionesjson.getIdInspeccion(),
				inspeccionesjson.getIdInspeccionMovil(), inspeccionesjson.getEstado(), inspeccionesjson.getError(),
				inspeccionesjson.getUsuarioUltmodificacion(), inspeccionesjson.getIdInspeccionJson());
		return inspeccionesjson;
	}

	/**
	 * Finds a single row in the InspeccionesJson table.
	 *
	 * @param inspeccionesjson
	 *            InspeccionesJson
	 * @return InspeccionesJson
	 */
	@Transactional(readOnly = true)
	public InspeccionesJson find(InspeccionesJson inspeccionesjson) {
		String query = "SELECT t1.ID_INSPECCION_JSON IDINSPECCIONJSON, t1.ID_INSPECCION IDINSPECCION, t1.ID_INSPECCION_MOVIL IDINSPECCIONMOVIL, t1.ESTADO ESTADO, t1.ERROR ERROR, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION, t2.ID_ENVIO_JSON ENVIOSJSONIDENVIOJSON, t2.APLICACION_ORIGEN ENVIOSJSONAPLICACIONORIGEN, t2.APLICACION_DESTINO ENVIOSJSONAPLICACIONDESTINO, t2.ID_INSPECTOR ENVIOSJSONIDINSPECTOR, t2.METODO ENVIOSJSONMETODO, t2.JSON ENVIOSJSONJSON, t2.ESTADO ENVIOSJSONESTADO, t2.FECHA_REGISTRO ENVIOSJSONFECHAREGISTRO, t2.USUARIO_REGISTRO ENVIOSJSONUSUARIOREGISTRO FROM INSPECCIONES_JSON t1 , ENVIOS_JSON t2  WHERE t1.ID_INSPECCION_JSON = ?   AND t1.ID_ENVIO_JSON= t2.ID_ENVIO_JSON(+)";

		List<InspeccionesJson> inspeccionesjsonList = this.jdbcTemplate.query(query, this.rwMap,
				inspeccionesjson.getIdInspeccionJson());
		return (InspeccionesJson) DataAccessUtils.uniqueResult(inspeccionesjsonList);
	}

	/**
	 * Removes a single row in the InspeccionesJson table.
	 *
	 * @param inspeccionesjson
	 *            InspeccionesJson
	 * @return
	 */
	public void remove(InspeccionesJson inspeccionesjson) {
		String query = "DELETE FROM INSPECCIONES_JSON WHERE ID_INSPECCION_JSON=?";
		this.jdbcTemplate.update(query, inspeccionesjson.getIdInspeccionJson());
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<InspeccionesJson> getMultiple(InspeccionesJson filterInspeccionesJson, TableRequestDto tableRequestDto,
			Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterInspeccionesJson, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, InspeccionesJson.class,
				params, "ID_INSPECCION_JSON");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the InspeccionesJson table.
	 *
	 * @param inspeccionesjson
	 *            InspeccionesJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<InspeccionesJson>
	 */
	@Transactional(readOnly = true)
	public List<InspeccionesJson> findAll(InspeccionesJson inspeccionesjson, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_INSPECCION_JSON IDINSPECCIONJSON,t1.ID_INSPECCION IDINSPECCION,t1.ID_INSPECCION_MOVIL IDINSPECCIONMOVIL,t1.ESTADO ESTADO,t1.ERROR ERROR,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t2.ID_ENVIO_JSON ENVIOSJSONIDENVIOJSON,t2.APLICACION_ORIGEN ENVIOSJSONAPLICACIONORIGEN,t2.APLICACION_DESTINO ENVIOSJSONAPLICACIONDESTINO,t2.ID_INSPECTOR ENVIOSJSONIDINSPECTOR,t2.METODO ENVIOSJSONMETODO, t2.JSON ENVIOSJSONJSON,t2.ESTADO ENVIOSJSONESTADO,t2.FECHA_REGISTRO ENVIOSJSONFECHAREGISTRO,t2.USUARIO_REGISTRO ENVIOSJSONUSUARIOREGISTRO ");
		query.append("FROM INSPECCIONES_JSON t1 ,ENVIOS_JSON t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(inspeccionesjson);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_ENVIO_JSON= t2.ID_ENVIO_JSON(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query,
					InspeccionesJsonDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<InspeccionesJson>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the InspeccionesJson table using like.
	 *
	 * @param inspeccionesjson
	 *            InspeccionesJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<InspeccionesJson>
	 */
	@Transactional(readOnly = true)
	public List<InspeccionesJson> findAllLike(InspeccionesJson inspeccionesjson, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_INSPECCION_JSON IDINSPECCIONJSON,t1.ID_INSPECCION IDINSPECCION,t1.ID_INSPECCION_MOVIL IDINSPECCIONMOVIL,t1.ESTADO ESTADO,t1.ERROR ERROR,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t2.METODO ENVIOSJSONMETODO, t2.ID_ENVIO_JSON ENVIOSJSONIDENVIOJSON,t2.APLICACION_ORIGEN ENVIOSJSONAPLICACIONORIGEN,t2.APLICACION_DESTINO ENVIOSJSONAPLICACIONDESTINO,t2.ID_INSPECTOR ENVIOSJSONIDINSPECTOR,t2.JSON ENVIOSJSONJSON,t2.ESTADO ENVIOSJSONESTADO,t2.FECHA_REGISTRO ENVIOSJSONFECHAREGISTRO,t2.USUARIO_REGISTRO ENVIOSJSONUSUARIOREGISTRO ");
		query.append("FROM INSPECCIONES_JSON t1 ,ENVIOS_JSON t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(inspeccionesjson, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_ENVIO_JSON= t2.ID_ENVIO_JSON(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query,
					InspeccionesJsonDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<InspeccionesJson>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the InspeccionesJson table.
	 *
	 * @param inspeccionesjson
	 *            InspeccionesJson
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(InspeccionesJson inspeccionesjson) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM INSPECCIONES_JSON t1 , ENVIOS_JSON t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(inspeccionesjson);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_ENVIO_JSON= t2.ID_ENVIO_JSON(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the InspeccionesJson table using like.
	 *
	 * @param inspeccionesjson
	 *            InspeccionesJson
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(InspeccionesJson inspeccionesjson, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM INSPECCIONES_JSON t1 ,ENVIOS_JSON t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(inspeccionesjson, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_ENVIO_JSON= t2.ID_ENVIO_JSON(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of InspeccionesJson selected for rup_table
	 *
	 * @param inspeccionesjson
	 *            InspeccionesJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<InspeccionesJson>>
	 */
	@Override
	public List<TableRowDto<InspeccionesJson>> reorderSelection(InspeccionesJson inspeccionesjson,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_INSPECCION_JSON IDINSPECCIONJSON,t1.ID_INSPECCION IDINSPECCION,t1.ID_INSPECCION_MOVIL IDINSPECCIONMOVIL,t1.ESTADO ESTADO,t1.ERROR ERROR,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t2.ID_ENVIO_JSON ENVIOSJSONIDENVIOJSON,t2.APLICACION_ORIGEN ENVIOSJSONAPLICACIONORIGEN,t2.APLICACION_DESTINO ENVIOSJSONAPLICACIONDESTINO,t2.ID_INSPECTOR ENVIOSJSONIDINSPECTOR,t2.JSON ENVIOSJSONJSON,t2.ESTADO ENVIOSJSONESTADO,t2.FECHA_REGISTRO ENVIOSJSONFECHAREGISTRO,t2.USUARIO_REGISTRO ENVIOSJSONUSUARIOREGISTRO ");
		// FROM
		query.append("FROM INSPECCIONES_JSON t1 ,ENVIOS_JSON t2 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(inspeccionesjson, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_ENVIO_JSON= t2.ID_ENVIO_JSON(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto,
				InspeccionesJson.class, filterParamList, "ID_INSPECCION_JSON");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<InspeccionesJson>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            InspeccionesJson
	 * @param searchParams
	 *            InspeccionesJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<InspeccionesJson>>
	 */
	@Override
	public List<TableRowDto<InspeccionesJson>> search(InspeccionesJson filterParams, InspeccionesJson searchParams,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_INSPECCION_JSON IDINSPECCIONJSON,t1.ID_INSPECCION IDINSPECCION,t1.ID_INSPECCION_MOVIL IDINSPECCIONMOVIL,t1.ESTADO ESTADO,t1.ERROR ERROR,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t2.ID_ENVIO_JSON ENVIOSJSONIDENVIOJSON,t2.APLICACION_ORIGEN ENVIOSJSONAPLICACIONORIGEN,t2.APLICACION_DESTINO ENVIOSJSONAPLICACIONDESTINO,t2.ID_INSPECTOR ENVIOSJSONIDINSPECTOR,t2.JSON ENVIOSJSONJSON,t2.ESTADO ENVIOSJSONESTADO,t2.FECHA_REGISTRO ENVIOSJSONFECHAREGISTRO,t2.USUARIO_REGISTRO ENVIOSJSONUSUARIOREGISTRO ");
		// FROM
		query.append("FROM INSPECCIONES_JSON t1 ,ENVIOS_JSON t2 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");
		from_alias.add(" t2 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_ENVIO_JSON= t2.ID_ENVIO_JSON(+) ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto,
				InspeccionesJson.class, filterParamList, searchSQL, searchParamList, from_alias, "ID_INSPECCION_JSON");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<InspeccionesJson>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filterinspeccionesjson
	 *            InspeccionesJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(InspeccionesJson filterinspeccionesjson, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_INSPECCION_JSON IDINSPECCIONJSON,t1.ID_INSPECCION IDINSPECCION,t1.ID_INSPECCION_MOVIL IDINSPECCIONMOVIL,t1.ESTADO ESTADO,t1.ERROR ERROR,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t2.ID_ENVIO_JSON ENVIOSJSONIDENVIOJSON,t2.APLICACION_ORIGEN ENVIOSJSONAPLICACIONORIGEN,t2.APLICACION_DESTINO ENVIOSJSONAPLICACIONDESTINO,t2.ID_INSPECTOR ENVIOSJSONIDINSPECTOR,t2.JSON ENVIOSJSONJSON,t2.ESTADO ENVIOSJSONESTADO,t2.FECHA_REGISTRO ENVIOSJSONFECHAREGISTRO,t2.USUARIO_REGISTRO ENVIOSJSONUSUARIOREGISTRO ");
		// FROM
		query.append("FROM INSPECCIONES_JSON t1 ,ENVIOS_JSON t2 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterinspeccionesjson, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto, InspeccionesJson.class,
				query, params, "ID_INSPECCION_JSON");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical InspeccionesJson table.
	 *
	 * @param filterInspeccionesJson
	 *            InspeccionesJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<InspeccionesJson>>
	 */
	@Override
	public List<JerarquiaDto<InspeccionesJson>> findAllLikeJerarquia(InspeccionesJson filterInspeccionesJson,
			TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_INSPECCION_JSON IDINSPECCIONJSON,t1.ID_INSPECCION IDINSPECCION,t1.ID_INSPECCION_MOVIL IDINSPECCIONMOVIL,t1.ESTADO ESTADO,t1.ERROR ERROR,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t2.ID_ENVIO_JSON ENVIOSJSONIDENVIOJSON,t2.APLICACION_ORIGEN ENVIOSJSONAPLICACIONORIGEN,t2.APLICACION_DESTINO ENVIOSJSONAPLICACIONDESTINO,t2.ID_INSPECTOR ENVIOSJSONIDINSPECTOR,t2.METODO ENVIOSJSONMETODO, t2.JSON ENVIOSJSONJSON,t2.ESTADO ENVIOSJSONESTADO,t2.FECHA_REGISTRO ENVIOSJSONFECHAREGISTRO,t2.USUARIO_REGISTRO ENVIOSJSONUSUARIOREGISTRO ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM INSPECCIONES_JSON t1
		// ,ENVIOS_JSON t2 ");
		List<String> from = new ArrayList<String>();
		from.add("INSPECCIONES_JSON");
		from.add("ENVIOS_JSON");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");
		from_alias.add(" t2 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterInspeccionesJson, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_INSPECCION_JSON", "ID_PADRE",
				"NOMBRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (tableRequestDto != null) {
			query = TableManagerJerarquia.getPaginationQuery(tableRequestDto, query,
					InspeccionesJsonDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterInspeccionesJson
	 *            InspeccionesJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(InspeccionesJson filterInspeccionesJson, TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM INSPECCIONES_JSON t1
		// ,ENVIOS_JSON t2 ");
		List<String> from = new ArrayList<String>();
		from.add("INSPECCIONES_JSON");
		from.add("ENVIOS_JSON");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");
		from_alias.add(" t2 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterInspeccionesJson, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_INSPECCION_JSON",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterInspeccionesJson
	 *            InspeccionesJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<InspeccionesJson>>
	 */
	@Override
	public List<TableRowDto<InspeccionesJson>> findAllChild(InspeccionesJson filterInspeccionesJson,
			TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM INSPECCIONES_JSON t1
		// ,ENVIOS_JSON t2 ");
		List<String> from = new ArrayList<String>();
		from.add("INSPECCIONES_JSON");
		from.add("ENVIOS_JSON");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");
		from_alias.add(" t2 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterInspeccionesJson, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere, "ID_INSPECCION_JSON",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<InspeccionesJson>(this.rwMapPK, "ID_INSPECCION_JSON"), params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the InspeccionesJson entity
	 *
	 * @param inspeccionesjson
	 *            InspeccionesJson Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(InspeccionesJson inspeccionesjson) {

		StringBuilder where = new StringBuilder(InspeccionesJsonDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (inspeccionesjson != null && inspeccionesjson.getIdInspeccionJson() != null) {
			where.append(" AND t1.ID_INSPECCION_JSON = ?");
			params.add(inspeccionesjson.getIdInspeccionJson());
		}
		if (inspeccionesjson != null && inspeccionesjson.getEnviosJson() != null
				&& inspeccionesjson.getEnviosJson().getIdEnvioJson() != null) {
			where.append(" AND t2.ID_ENVIO_JSON = ?");
			params.add(inspeccionesjson.getEnviosJson().getIdEnvioJson());
		}
		if (inspeccionesjson != null && inspeccionesjson.getEnviosJson() != null
				&& inspeccionesjson.getEnviosJson().getAplicacionOrigen() != null) {
			where.append(" AND t2.APLICACION_ORIGEN = ?");
			params.add(inspeccionesjson.getEnviosJson().getAplicacionOrigen());
		}
		if (inspeccionesjson != null && inspeccionesjson.getEnviosJson() != null
				&& inspeccionesjson.getEnviosJson().getAplicacionDestino() != null) {
			where.append(" AND t2.APLICACION_DESTINO = ?");
			params.add(inspeccionesjson.getEnviosJson().getAplicacionDestino());
		}
		if (inspeccionesjson != null && inspeccionesjson.getEnviosJson() != null
				&& inspeccionesjson.getEnviosJson().getIdInspector() != null) {
			where.append(" AND t2.ID_INSPECTOR = ?");
			params.add(inspeccionesjson.getEnviosJson().getIdInspector());
		}
		if (inspeccionesjson != null && inspeccionesjson.getEnviosJson() != null
				&& inspeccionesjson.getEnviosJson().getEstado() != null) {
			where.append(" AND t2.ESTADO = ?");
			params.add(inspeccionesjson.getEnviosJson().getEstado());
		}
		if (inspeccionesjson != null && inspeccionesjson.getEnviosJson() != null
				&& inspeccionesjson.getEnviosJson().getFechaRegistro() != null) {
			where.append(" AND t2.FECHA_REGISTRO = ?");
			params.add(inspeccionesjson.getEnviosJson().getFechaRegistro());
		}
		if (inspeccionesjson != null && inspeccionesjson.getEnviosJson() != null
				&& inspeccionesjson.getEnviosJson().getUsuarioRegistro() != null) {
			where.append(" AND t2.USUARIO_REGISTRO = ?");
			params.add(inspeccionesjson.getEnviosJson().getUsuarioRegistro());
		}
		if (inspeccionesjson != null && inspeccionesjson.getIdInspeccion() != null) {
			where.append(" AND t1.ID_INSPECCION = ?");
			params.add(inspeccionesjson.getIdInspeccion());
		}
		if (inspeccionesjson != null && inspeccionesjson.getIdInspeccionMovil() != null) {
			where.append(" AND t1.ID_INSPECCION_MOVIL = ?");
			params.add(inspeccionesjson.getIdInspeccionMovil());
		}
		if (inspeccionesjson != null && inspeccionesjson.getEstado() != null) {
			where.append(" AND t1.ESTADO = ?");
			params.add(inspeccionesjson.getEstado());
		}
		if (inspeccionesjson != null && inspeccionesjson.getError() != null) {
			where.append(" AND t1.ERROR = ?");
			params.add(inspeccionesjson.getError());
		}
		if (inspeccionesjson != null && inspeccionesjson.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(inspeccionesjson.getFechaRegistro());
		}
		if (inspeccionesjson != null && inspeccionesjson.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(inspeccionesjson.getUsuarioRegistro());
		}
		if (inspeccionesjson != null && inspeccionesjson.getFechaUltmodificacion() != null) {
			where.append(" AND t1.FECHA_ULTMODIFICACION = ?");
			params.add(inspeccionesjson.getFechaUltmodificacion());
		}
		if (inspeccionesjson != null && inspeccionesjson.getUsuarioUltmodificacion() != null) {
			where.append(" AND t1.USUARIO_ULTMODIFICACION = ?");
			params.add(inspeccionesjson.getUsuarioUltmodificacion());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the InspeccionesJson entity
	 *
	 * @param inspeccionesjson
	 *            InspeccionesJson Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(InspeccionesJson inspeccionesjson, Boolean startsWith) {

		StringBuilder where = new StringBuilder(InspeccionesJsonDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (inspeccionesjson != null && inspeccionesjson.getIdInspeccionJson() != null) {
			where.append(" AND t1.ID_INSPECCION_JSON = ?");
			params.add(inspeccionesjson.getIdInspeccionJson());
		}
		if (inspeccionesjson != null && inspeccionesjson.getEnviosJson() != null
				&& inspeccionesjson.getEnviosJson().getIdEnvioJson() != null) {
			where.append(" AND t2.ID_ENVIO_JSON = ?");
			params.add(inspeccionesjson.getEnviosJson().getIdEnvioJson());
		}
		if (inspeccionesjson != null && inspeccionesjson.getEnviosJson() != null
				&& inspeccionesjson.getEnviosJson().getAplicacionOrigen() != null) {
			where.append(" AND UPPER(t2.APLICACION_ORIGEN) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(inspeccionesjson.getEnviosJson().getAplicacionOrigen().toUpperCase() + "%");
			} else {
				params.add("%" + inspeccionesjson.getEnviosJson().getAplicacionOrigen().toUpperCase() + "%");
			}
			where.append(" AND t2.APLICACION_ORIGEN IS NOT NULL");
		}
		if (inspeccionesjson != null && inspeccionesjson.getEnviosJson() != null
				&& inspeccionesjson.getEnviosJson().getAplicacionDestino() != null) {
			where.append(" AND UPPER(t2.APLICACION_DESTINO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(inspeccionesjson.getEnviosJson().getAplicacionDestino().toUpperCase() + "%");
			} else {
				params.add("%" + inspeccionesjson.getEnviosJson().getAplicacionDestino().toUpperCase() + "%");
			}
			where.append(" AND t2.APLICACION_DESTINO IS NOT NULL");
		}
		if (inspeccionesjson != null && inspeccionesjson.getEnviosJson() != null
				&& inspeccionesjson.getEnviosJson().getIdInspector() != null) {
			where.append(" AND t2.ID_INSPECTOR = ?");
			params.add(inspeccionesjson.getEnviosJson().getIdInspector());
		}
		if (inspeccionesjson != null && inspeccionesjson.getEnviosJson() != null
				&& inspeccionesjson.getEnviosJson().getEstado() != null) {
			where.append(" AND t2.ESTADO = ?");
			params.add(inspeccionesjson.getEnviosJson().getEstado());
		}
		if (inspeccionesjson != null && inspeccionesjson.getEnviosJson() != null
				&& inspeccionesjson.getEnviosJson().getFechaRegistro() != null) {
			where.append(" AND t2.FECHA_REGISTRO = ?");
			params.add(inspeccionesjson.getEnviosJson().getFechaRegistro());
		}
		if (inspeccionesjson != null && inspeccionesjson.getEnviosJson() != null
				&& inspeccionesjson.getEnviosJson().getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t2.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(inspeccionesjson.getEnviosJson().getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + inspeccionesjson.getEnviosJson().getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t2.USUARIO_REGISTRO IS NOT NULL");
		}
		if (inspeccionesjson != null && inspeccionesjson.getIdInspeccion() != null) {
			where.append(" AND t1.ID_INSPECCION = ?");
			params.add(inspeccionesjson.getIdInspeccion());
		}
		if (inspeccionesjson != null && inspeccionesjson.getIdInspeccionMovil() != null) {
			where.append(" AND UPPER(t1.ID_INSPECCION_MOVIL) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(inspeccionesjson.getIdInspeccionMovil().toUpperCase() + "%");
			} else {
				params.add("%" + inspeccionesjson.getIdInspeccionMovil().toUpperCase() + "%");
			}
			where.append(" AND t1.ID_INSPECCION_MOVIL IS NOT NULL");
		}
		if (inspeccionesjson != null && inspeccionesjson.getEstado() != null) {
			where.append(" AND t1.ESTADO = ?");
			params.add(inspeccionesjson.getEstado());
		}
		if (inspeccionesjson != null && inspeccionesjson.getError() != null) {
			where.append(" AND UPPER(t1.ERROR) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(inspeccionesjson.getError().toUpperCase() + "%");
			} else {
				params.add("%" + inspeccionesjson.getError().toUpperCase() + "%");
			}
			where.append(" AND t1.ERROR IS NOT NULL");
		}
		if (inspeccionesjson != null && inspeccionesjson.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(inspeccionesjson.getFechaRegistro());
		}
		if (inspeccionesjson != null && inspeccionesjson.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(inspeccionesjson.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + inspeccionesjson.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}
		if (inspeccionesjson != null && inspeccionesjson.getFechaUltmodificacion() != null) {
			where.append(" AND t1.FECHA_ULTMODIFICACION = ?");
			params.add(inspeccionesjson.getFechaUltmodificacion());
		}
		if (inspeccionesjson != null && inspeccionesjson.getUsuarioUltmodificacion() != null) {
			where.append(" AND UPPER(t1.USUARIO_ULTMODIFICACION) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(inspeccionesjson.getUsuarioUltmodificacion().toUpperCase() + "%");
			} else {
				params.add("%" + inspeccionesjson.getUsuarioUltmodificacion().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_ULTMODIFICACION IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;
}
